// inqybrws.cpp : implementation file
//

#include "stdafx.h"
#include "inqyx.h"
#include "inqybrws.h"

// Defines for user COMMAREA lengths
#define BROWSECOMMSIZE  14
#define BROWSEINPUTLEN	1
#define BRWSTRAN "NEWCBRW "

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Include for CICS ECI functions
#define CICS_W32
#include <cicseci.hpp>

// Include for subclassed ECI object to fix problem getting abend code
#include "clnterr.h"

/////////////////////////////////////////////////////////////////////////////
// inqybrws

IMPLEMENT_DYNCREATE(inqybrws, CCmdTarget)

inqybrws::inqybrws()

{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();

	// Allocate a CICS COMMAREA
	pComm = new COMMAREA;
}

inqybrws::~inqybrws()

{
	// Release our commarea storage
	delete pComm;
	
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	AfxOleUnlockApp();
}


void inqybrws::OnFinalRelease()

{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(inqybrws, CCmdTarget)
	//{{AFX_MSG_MAP(inqybrws)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(inqybrws, CCmdTarget)
	//{{AFX_DISPATCH_MAP(inqybrws)
	DISP_PROPERTY(inqybrws, "acctno1", m_acctno1, VT_BSTR)
	DISP_PROPERTY(inqybrws, "acctno2", m_acctno2, VT_BSTR)
	DISP_PROPERTY(inqybrws, "acctno3", m_acctno3, VT_BSTR)
	DISP_PROPERTY(inqybrws, "acctno4", m_acctno4, VT_BSTR)
	DISP_PROPERTY(inqybrws, "name1", m_name1, VT_BSTR)
	DISP_PROPERTY(inqybrws, "name2", m_name2, VT_BSTR)
	DISP_PROPERTY(inqybrws, "name3", m_name3, VT_BSTR)
	DISP_PROPERTY(inqybrws, "name4", m_name4, VT_BSTR)
	DISP_PROPERTY(inqybrws, "amount1", m_amount1, VT_BSTR)
	DISP_PROPERTY(inqybrws, "amount2", m_amount2, VT_BSTR)
	DISP_PROPERTY(inqybrws, "amount3", m_amount3, VT_BSTR)
	DISP_PROPERTY(inqybrws, "amount4", m_amount4, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brerrmsg", m_brerrmsg, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brerrmsg2", m_brerrmsg2, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brerrmsg3", m_brerrmsg3, VT_BSTR)
	DISP_PROPERTY(inqybrws, "bruser", m_bruser, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brpw", m_brpw, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brsystem", m_brsystem, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brclient", m_brclient, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brecierrmsg", m_brecierrmsg, VT_BSTR)
	DISP_PROPERTY(inqybrws, "brabcode", m_brabcode, VT_BSTR)
	DISP_FUNCTION(inqybrws, "executeStartBrowse", executeStartBrowse, VT_I2, VTS_BSTR)
	DISP_FUNCTION(inqybrws, "executeBrowseNext", executeBrowseNext, VT_I2, VTS_I2)
	DISP_FUNCTION(inqybrws, "setCICSparms", setCICSparms, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_Iinqybrws to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {26026F34-B8E2-11D1-BBB4-08005AA55FA5}
static const IID IID_Iinqybrws =
{ 0x26026f34, 0xb8e2, 0x11d1, { 0xbb, 0xb4, 0x8, 0x0, 0x5a, 0xa5, 0x5f, 0xa5 } };

BEGIN_INTERFACE_MAP(inqybrws, CCmdTarget)
	INTERFACE_PART(inqybrws, IID_Iinqybrws, Dispatch)
END_INTERFACE_MAP()

// {26026F35-B8E2-11D1-BBB4-08005AA55FA5}
IMPLEMENT_OLECREATE(inqybrws, "inqyx.inqybrws", 0x26026f35, 0xb8e2, 0x11d1, 0xbb, 0xb4, 0x8, 0x0, 0x5a, 0xa5, 0x5f, 0xa5)

/////////////////////////////////////////////////////////////////////////////
// inqybrws message handlers

short inqybrws::executeStartBrowse(LPCTSTR acctno) 

{
	// Get the account number
	CString acct = acctno;

	// TODO: Add your dispatch handler code here
	// Set the BMS map fields
	setMenuMapData(acct);

	// set the transaction code 
	memcpy(pComm->brws.comm_head.USRTRNID,"BRWS",4);

	// set the user COMMAREA length to zero
	memset(pComm->brws.comm_head.USRCALEN, '0',
           sizeof(pComm->inqy.comm_head.USRCALEN));

	// set the version number to zero
	memset(pComm->brws.comm_head.VERSION, '0',
			sizeof(pComm->brws.comm_head.VERSION));

	// End of COMMAREA build

	// Execute the CICS Transaction and update the instance variables
	short rc = executeCICSTran(BRWSTRAN);

	return rc;
}

short inqybrws::executeBrowseNext(short direction) 

{
	// TODO: Add your dispatch handler code here

	// Clear the map areas to nulls
	//memset(pComm->brws.browse.dfhdgci, '\0', sizeof(pComm->brws.browse.dfhdgc));
	//memset(pComm->brws.menu.dfhcgai, '\0', sizeof(pComm->brws.menu.dfhdga));

	// Set the direction to forwards or backwards
	if (direction == 0)
	{
		pComm->brws.browse.dfhdgci.diri = 'F';
	}
	else
	{
		pComm->brws.browse.dfhdgci.diri = 'B';
	}

	// Set the BMS field length
    pComm->brws.browse.dfhdgci.dirl = 1;

	// Set the total map length
	CInqyxApp::int2char(BROWSEINPUTLEN, pComm->inqy.comm_head.USRMAPLN,
						sizeof(pComm->inqy.comm_head.USRMAPLN));
	
	// set the user commarea and length 
	CInqyxApp::int2char(BROWSECOMMSIZE, pComm->brws.comm_head.USRCALEN,
						sizeof(pComm->brws.comm_head.USRCALEN));

	// set the map name 
	memcpy(pComm->brws.comm_head.MAPNAME,"BROWSE  ",8);

	// set the transaction code 
	memcpy(pComm->brws.comm_head.USRTRNID,"BRWS",4);

	// Set the Client Name field in the COMMAREA
	CInqyxApp::move_comm(m_brclient, pComm->brws.comm_head.USRTRMID, 
 						 sizeof(pComm->brws.comm_head.USRTRMID), ALPHA_FIELD);

	// set the version number to zero
	memset(pComm->brws.comm_head.VERSION, '0',
			sizeof(pComm->brws.comm_head.VERSION));

	// End of COMMAREA build

	// Execute the CICS Transaction and update the instance variables
	short rc = executeCICSTran(BRWSTRAN);

	return rc;
}

// Subroutine to set the data in the Menu map
//

void inqybrws::setMenuMapData(CString& acctno)

{
	// Total length of all input data in map
	short maplen = 0;

	// Clear the data area to nulls
	memset(pComm, '\0', sizeof(COMMAREA));

	// Set the Client Name field in the COMMAREA
	CInqyxApp::move_comm(m_brclient, pComm->brws.comm_head.USRTRMID, 
						 sizeof(pComm->brws.comm_head.USRTRMID), ALPHA_FIELD);

	// set the account number from the instance variable
	CInqyxApp::moveBMSfield(acctno,
							pComm->brws.menu.dfhdgai.keyi,
							&pComm->brws.menu.dfhdgai.keyl,
							&maplen,
							sizeof(pComm->brws.menu.dfhdgai.keyi),
							NUMERIC_FIELD);

	// set the map name
	memcpy(pComm->inqy.comm_head.MAPNAME,"MENU    ",8);
}

// Subroutine to get data out of the COMMAREA and into
//  properties

void inqybrws::getDataFromComm()

{
	// Check for a CICS SEND TEXT
	if (memcmp(pComm->inqy.comm_head.MAPNAME,"SENDTEXT",
			   sizeof(pComm->inqy.comm_head.MAPNAME)) == 0)
	{
		CInqyxApp::comm_move(m_brerrmsg, pComm->inqy.comm_head.textarea,
							 sizeof(pComm->inqy.comm_head.textarea));
	} // endif

   if (memcmp(pComm->brws.comm_head.MAPNAME,"BROWSE  ",
              sizeof(pComm->brws.comm_head.MAPNAME)) == 0)
   {
      CInqyxApp::comm_move(m_acctno1, pComm->brws.browse.dfhdgco.number1o,
						   sizeof(pComm->brws.browse.dfhdgco.number1o));

      CInqyxApp::comm_move(m_name1, pComm->brws.browse.dfhdgco.name1o,
						   sizeof(pComm->brws.browse.dfhdgco.name1o));

      CInqyxApp::comm_move(m_amount1, pComm->brws.browse.dfhdgco.amount1o,
						   sizeof(pComm->brws.browse.dfhdgco.amount1o));

      CInqyxApp::comm_move(m_acctno2, pComm->brws.browse.dfhdgco.number2o,
						   sizeof(pComm->brws.browse.dfhdgco.number2o));

      CInqyxApp::comm_move(m_name2, pComm->brws.browse.dfhdgco.name2o,
						   sizeof(pComm->brws.browse.dfhdgco.name2o));

      CInqyxApp::comm_move(m_amount2, pComm->brws.browse.dfhdgco.amount2o,
						   sizeof(pComm->brws.browse.dfhdgco.amount2o));

      CInqyxApp::comm_move(m_acctno3, pComm->brws.browse.dfhdgco.number3o,
						   sizeof(pComm->brws.browse.dfhdgco.number3o));

      CInqyxApp::comm_move(m_name3, pComm->brws.browse.dfhdgco.name3o,
						   sizeof(pComm->brws.browse.dfhdgco.name3o));

      CInqyxApp::comm_move(m_amount3, pComm->brws.browse.dfhdgco.amount3o,
						   sizeof(pComm->brws.browse.dfhdgco.amount3o));

      CInqyxApp::comm_move(m_acctno4, pComm->brws.browse.dfhdgco.number4o,
						   sizeof(pComm->brws.browse.dfhdgco.number4o));

      CInqyxApp::comm_move(m_name4, pComm->brws.browse.dfhdgco.name4o,
						   sizeof(pComm->brws.browse.dfhdgco.name4o));

      CInqyxApp::comm_move(m_amount4, pComm->brws.browse.dfhdgco.amount4o,
						   sizeof(pComm->brws.browse.dfhdgco.amount4o));

      CInqyxApp::comm_move(m_brerrmsg, pComm->brws.browse.dfhdgco.msg2o,
						   sizeof(pComm->brws.browse.dfhdgco.msg2o));

      CInqyxApp::comm_move(m_brerrmsg2, pComm->brws.browse.dfhdgco.msg0o,
						   sizeof(pComm->brws.browse.dfhdgco.msg0o));

      CInqyxApp::comm_move(m_brerrmsg3, pComm->brws.browse.dfhdgco.msg1o,
						   sizeof(pComm->brws.browse.dfhdgco.msg1o));
   }
}

short inqybrws::executeCICSTran(char* tran)

{
	short RC = 0;

	// The ECI object is assumed to have been built in the logon dll
	// If not, then the following comment should be removed and
	// the line after that removed.  The use of the ECI object
	// below to get the abend code must be changed from a pointer
	// reference (->) to a member reference (.)
	//fixCclECI inqyECI;
	fixCclECI* inqyECI = (fixCclECI*) CclECI::instance();

	// Build comm, buffer and a flow objects
	CclBuf buffer(sizeof(COMMAREA),pComm);
	CclFlow sflow(Ccl::sync);
	CclConn connection(m_brsystem, m_bruser, m_brpw);

	// Clear the previous CICS error message text
	m_brecierrmsg.Empty();
	m_brabcode.Empty();
	m_brerrmsg.Empty();

	try {	// Catch block for CclClass exceptions
			connection.link(sflow, tran, &buffer);
			getDataFromComm();
	    }    // Catch CclClass exceptions
	catch ( CclException& exception ) 
		{
			RC = exception.exCode();
			m_brecierrmsg = exception.exCodeText();
			m_brabcode = inqyECI->m_Cclabcode;
			// Now, be realy daring and try to throw an exception back
			// through OLE to the Visual Basic program
			// the following lines are commented out
			// They will pass the exception back to the visual basic
			// program.  This requires the VB program to have an
			// ON ERROR statement active to catch the exception.
			// If this support is desired, then remove the comments 
			// and recompile the DLL
//			COleDispatchException* pException = new COleDispatchException(
//				m_ecierrmsg, 200, RC);
//			pException->m_scError = 0;
			// Throw the exception back to VB
//			throw(pException);
        } // end catch

	return RC;
}

void inqybrws::setCICSparms(LPCTSTR userid, LPCTSTR password, LPCTSTR system, LPCTSTR client) 
{
	// TODO: Add your dispatch handler code here
	m_bruser   = userid;
	m_brpw     = password;
	m_brsystem = system;
	m_brclient = client;

}
